--[[
local ache_gold_diam =
{    
    ["1"] =  {gold = 10, diam = 0},
    ["2"] =  {gold = 6,  diam = 0},
    ["3"] =  {gold = 6,  diam = 0},
    ["4"] =  {gold = 2,  diam = 0},
    ["5"] =  {gold = 3,  diam = 0},
    ["6"] =  {gold = 4,  diam = 0},
    ["7"] =  {gold = 5,  diam = 0},
    ["8"] =  {gold = 10, diam = 0},
    ["9"] =  {gold = 3,  diam = 0},
    ["10"] = {gold = 4,  diam = 0},
    ["11"] = {gold = 0,  diam = 1},    
    ["12"] = {gold = 2,  diam = 0},
    ["13"] = {gold = 2,  diam = 0},
    ["14"] = {gold = 0,  diam = 1},
    ["15"] = {gold = 0,  diam = 1},
    ["16"] = {gold = 0,  diam = 2},
    ["17"] = {gold = 0,  diam = 2},
    ["18"] = {gold = 0,  diam = 2},
    ["19"] = {gold = 0,  diam = 2},
    ["20"] = {gold = 0,  diam = 2},
    ["21"] = {gold = 0,  diam = 2},
    ["22"] = {gold = 0,  diam = 2},
    ["23"] = {gold = 0,  diam = 2},
    ["24"] = {gold = 0,  diam = 2},
    ["25"] = {gold = 10, diam = 0},
    ["26"] = {gold = 10, diam = 0},
    ["27"] = {gold = 3,  diam = 0},
    ["28"] = {gold = 3,  diam = 0},
    ["29"] = {gold = 3,  diam = 0},
    ["30"] = {gold = 0,  diam = 2},    
    ["31"] = {gold = 4,  diam = 0},
    ["32"] = {gold = 5,  diam = 0},
    ["33"] = {gold = 3,  diam = 0},
    ["34"] = {gold = 3,  diam = 0}
}

local function loadAch()
	local path = CCFileUtils:sharedFileUtils():getWriteablePath().."achieve.txt"
	if io.exists(path) then
		infoAch = loadFile(path)
	else
		infoAch = {}
	end
end

local function saveAchFirst()
	local writeName = CCFileUtils:sharedFileUtils():getWriteablePath().."achieve.txt"
	if not io.exists(writeName) then
		local achTmp={}
		for i = 1, speNums.achLen do
			local achInner = {}
            achTmp["x_ach"..i] = 0
            achInner["gold"] = ache_gold_diam[""..i].gold
            achInner["diamond"] = ache_gold_diam[""..i].diam
			achInner["isGet"] = 0
			achInner["isPlay"] = 0
			achInner["isFinish"] = 0
			achTmp[""..i] = achInner
		end
		io.writefile(writeName, gJSON:encode(achTmp))
	end
end

local function achTipDel()
	local tipSpr = twoLayer:getChildByTag(tagNums["twoLayer"].achTip)
	if tipSpr then
		tipSpr:stopAllActions()
		twoLayer:removeChildByTag(tagNums["twoLayer"].achTip)
	end
end

function calSaveLoadAch()
    calAchAndSave()
    loadAch()
end

--only used
function loadAchFirst()
	saveAchFirst()
	loadAch()
	calAchAndSave()
end

function calAchAndSave()
	if infoAch then
		for i = 1, speNums.achLen do
            if infoAch[""..i]["isFinish"] ~= 1 and infoAch["x_ach"..i] >= target["con"..i][1] then
                infoAch[""..i]["isFinish"] = 1
            end
		end
	end
    saveAchSep()
end

function culateAchieve()
    for m = 1, 12 do
        if infoSours["todayDefeatBoss"][m] then
            infoAch["x_ach1"] = infoAch["x_ach1"] + infoSours["todayDefeatBoss"][m]
        end	
    end
    infoAch["x_ach2"] = infoSours["x_todayScore"]
    infoAch["x_ach3"] = infoSours["x_todayBuy"] 
    infoAch["x_ach4"] = infoSours["x_overEye"]   
	infoAch["x_ach5"] = infoSours["x_gameTime"]
	infoAch["x_ach6"] = infoSours["x_gameTime"]
	infoAch["x_ach7"] = infoSours["x_gameTime"]
	infoAch["x_ach8"] = infoSours["x_gameTime"]     
	infoAch["x_ach9"] = infoSours["x_shootBubAll"]
	infoAch["x_ach10"] = infoSours["x_shootBubAll"]   
	infoAch["x_ach11"] = infoSours["x_buyOneDota"]    
	infoAch["x_ach12"] = infoSours["x_bestScore"]
    infoAch["x_ach13"] = infoSours["x_failBubAll"]    
	for ach_k = 14, 23 do
        local k = ach_k - 13
        if infoSours["maxLev_"..k]["x_nineopen"] == 1 then
            infoAch["x_ach"..ach_k] = 1
        end	
    end
    if infoSours["maxLev_12"]["x_nineopen"] == 1 then
        infoAch["x_ach24"] = 1
    end
	infoAch["x_ach25"] = infoSours["x_lossDiamond"]
    for i = 1, 12 do
        local mostLev = largeToSmall["lar_"..i][1]
        for j = 1, mostLev do
            if infoSours["maxLev_"..i]["starNum"][j] >= 2 then
                infoAch["x_ach26"] = infoAch["x_ach26"] + 1
            end
        end
    end    
    infoAch["x_ach27"] = infoSours["x_mulNum"]
    infoAch["x_ach28"] = infoSours["x_bombNum"]
	infoAch["x_ach29"] = infoSours["x_steelNum"] 
    for i = 1, 12 do
        local mostLev = largeToSmall["lar_"..i][1]
        local sepSceneAllStars = 3 * mostLev
        local num_tmp = 0
        for j = 1, mostLev do
            if infoSours["maxLev_"..i]["starNum"][j] then
                num_tmp = num_tmp + infoSours["maxLev_"..i]["starNum"][j]
            end
        end        
        if num_tmp >= sepSceneAllStars then
            infoAch["x_ach30"] = 1
            break
        end
    end
	infoAch["x_ach31"] = infoSours["x_gameAllScore"]
	infoAch["x_ach32"] = infoSours["x_gameAllScore"]
	infoAch["x_ach33"] = infoSours["x_shootBubAll"]
	if infoSours["maxLev_12"]["x_nineopen"] == 1 then
        infoAch["x_ach34"] = 1
    end
end

function updateAch(i)
    infoAch[""..i]["isGet"] = 1
    saveAchSep()
end

function achTips()
    if not isGameLayerPause then return end
	local canGetAch = 0
	for ij = 1, speNums.achLen do
		if infoAch[""..ij].isFinish == 1 and infoAch[""..ij].isGet == 0 and infoAch[""..ij].isPlay == 0 then
			canGetAch = ij
            break
		end
	end
	if canGetAch == 0 then return end
	infoAch[""..canGetAch].isPlay = 1
	saveAchSep()
    local achpic = "ach_top.png"
    if device == "ipad" then achpic = "ach_top_ipad.png" end
	local tipSpr = CCSprite:create(REPATHBJ..achpic)
	tipSpr:setPosition(840*adrate, 830*adrate)
    local ch_ach_tmp = ch_ach
    if enviorLanguage == 1 then
        ch_ach_tmp = ch_ach_ch
    end
	local surprised =CCLabelTTF:create(ch_ach_tmp["ach_"..canGetAch][2], letter_ttf, 25)
	surprised:setDimensions(CCSize(200, 72))
	surprised:setHorizontalAlignment(UITextAlignmentCenter)
	surprised:setColor(ccc3(255, 255, 0))
	surprised:setPosition(190*adrate, 30*adrate)
	tipSpr:addChild(surprised)

	twoLayer:addChild(tipSpr, 1, tagNums["twoLayer"].achTip)
    canGetAch = 0
	soundAchieveOneAch()
    local dy = 0
    if device == "ipad" then dy = 32 end
	tipSpr:runAction(CCMoveTo:create(0.3, ccp(485 + dy, 830)))
	performWithDelay(3, achTipMove)
end

function achTipMove()
	local tipSpr = twoLayer:getChildByTag(tagNums["twoLayer"].achTip)
	if tipSpr then
		tipSpr:runAction(CCMoveTo:create(0.3, ccp(840, 830)))
		performWithDelay(0.4, achTipDel)
	end
end
]]