--先调用
function delDoor()
    if not isGameLayerPause then
        return
    end
    doorFirstFlag = false
    doorLastFlag = false
    doorLast  = 0
    doorFirst = 0                    
    linkDoorNum1 = 0
    linkDoorNum2 = 0
    doorLine1 = 0
    doorLine2 = 0
    doorCol1  = 0
    doorCol2  = 0
    
    --doorSprite1与doorSprite2成对处理
    delDoorTwoSprites()
    
    --选出不为空的球
    local doorTable = chanDoorSearch()
    if #doorTable < 6 then return end
    
    --第一个传送门
    judgelinkDoor1(doorTable)
    --第二个传送门
    if doorFirstFlag then
        judgelinkDoor2(doorTable)
    end
    if not doorFirstFlag or not doorLastFlag then
        return
    end
    
    local door_seq_1 = (doorLine1 - 1) * colNum + doorCol1
    local door_seq_2 = (doorLine2 - 1) * colNum + doorCol2
    if door_seq_1 ~= door_seq_2 and curBubLevel[door_seq_1] and curBubLevel[door_seq_1] == 0  and 
        curBubLevel[door_seq_2] and curBubLevel[door_seq_2] == 0 then
        addDoorSpr()
    end
end

function removeTwoDoor()
    if doorSprite1 and doorSprite2 then
        local doorSeq1 = doorSprite1.seq
        sours[doorSeq1] = 0
        curBubLevel[doorSeq1] = 0
        shootLayer:removeChild(doorSprite1)
        local doorSeq2 = doorSprite2.seq
        sours[doorSeq2] = 0
        curBubLevel[doorSeq2] = 0
        shootLayer:removeChild(doorSprite2)
        
        recursionStart()
    end
end

function chanDoorSearch()
    local doorTable = {}
    local door_disG = gStartY - startY
    local minH = math.min(screenHeight, startY)
    local h_tmp = minH - bub_height * 2
	if curBubLevel then
		for i = #curBubLevel, 1, -1 do
			if curBubLevel[i] and curBubLevel[i] ~= 0 then
				local door_fixY = curBubLevel[i]:getPositionY()
                door_fixY = door_fixY - door_disG
                if door_fixY > h_tmp then break end
				table.insert(doorTable,curBubLevel[i])
			end
		end
	end
    
    return doorTable
end

--必须与现有的球相连
function judgelinkDoor1(doorTable)
    linkDoorNum1 = linkDoorNum1 + 1
    if linkDoorNum1 > 3 then 
        return
    end
    
    local ssDoor1 = doorTable[math.random(#doorTable)]
    local col,line = getHexagonDoor(ssDoor1.seq)
    door1re(line,col)
    if not doorFirstFlag then
        judgelinkDoor1(doorTable)
    end
end

function door1re(line, col)
    if line <= 0 or line > lineNum or col <= 0 or col > colNum then
		return
	end
	local xy = (line - 1) * colNum + col
    if curBubLevel[xy]  and curBubLevel[xy] ~= 0 then
        local k = line % 2 
		if k == 0 then k = -1 end
		if not doorFirstFlag then recursionDoor1(line - 1, col - k) end
		if not doorFirstFlag then recursionDoor1(line - 1, col) end
		if not doorFirstFlag then recursionDoor1(line, col - 1) end
		if not doorFirstFlag then recursionDoor1(line, col + 1) end
		if not doorFirstFlag then recursionDoor1(line + 1, col - k) end
		if not doorFirstFlag then recursionDoor1(line + 1, col) end
	end
end

function recursionDoor1(line_1, col_1)
	if line_1 <= 0 or line_1 > lineNum or col_1 <= 0 or col_1 > colNum then
		return
	end
	local door_xy = (line_1 - 1) * colNum + col_1
    if curBubLevel[door_xy] and curBubLevel[door_xy] == 0 then
        doorLine1 = line_1
        doorCol1  = col_1
        doorFirst = door_xy
        doorFirstFlag = true
	end
end

--必须与现有的球相连
function judgelinkDoor2(doorTable)
    linkDoorNum2 = linkDoorNum2 + 1
    if linkDoorNum2 > 3 then
        return 
    end 
    local ssDoor2 = doorTable[math.random(#doorTable)]
    local col,line = getHexagonDoor(ssDoor2.seq)
    door2re(line,col)
    if not doorLastFlag or doorLast == doorFirst then
        judgelinkDoor2(doorTable)
    end  
end

function door2re(line, col)
    if line <= 0 or line > lineNum or col <= 0 or col > colNum then
		return
	end
	local xy = (line - 1) * colNum + col
    if curBubLevel[xy] and curBubLevel[xy] ~= 0 then
		local k = line % 2 
		if k == 0 then k = -1 end
		if not doorLastFlag then recursionDoor2(line - 1, col - k) end
		if not doorLastFlag then recursionDoor2(line - 1, col) end
		if not doorLastFlag then recursionDoor2(line, col - 1) end
		if not doorLastFlag then recursionDoor2(line, col + 1) end
		if not doorLastFlag then recursionDoor2(line + 1, col - k) end
		if not doorLastFlag then recursionDoor2(line + 1, col) end
	end
end

function recursionDoor2(line_2, col_2)
	if line_2 <= 0 or line_2 > lineNum or col_2 <= 0 or col_2 > colNum then
		return
	end
	local door_xy = (line_2 - 1) * colNum + col_2
    if curBubLevel[door_xy] and curBubLevel[door_xy] == 0 then
        doorLine2 = line_2
        doorCol2  = col_2
        doorLast = door_xy
        doorLastFlag = true
	end
end

function addDoorSpr()    
    --2个传送门精灵
    doorSprite1 = nil
    doorSprite2 = nil
    
    local spr_doorFirst = curBubLevel[doorFirst]
    local spr_doorLast = curBubLevel[doorLast]
    if spr_doorFirst ~= 0 then return end
    if spr_doorLast ~= 0 then return end
    
    --cclog("doorLine1 = "..doorLine1..",doorCol1="..doorCol1..",doorLine2="..doorLine2..",doorCol2="..doorCol2)
    local door_seq_1 = (doorLine1 - 1) * colNum + doorCol1
    local door_seq_2 = (doorLine2 - 1) * colNum + doorCol2
    if shootLayer:getChildByTag(tagNums["shootLayer"].shoot + door_seq_1) or 
        shootLayer:getChildByTag(tagNums["shootLayer"].shoot + door_seq_2) then
        doorFirstFlag = false
        doorLastFlag = false
        doorLast  = 0
        doorFirst = 0                    
        linkDoorNum1 = 0
        linkDoorNum2 = 0
        doorLine1 = 0
        doorLine2 = 0
        doorCol1  = 0
        doorCol2  = 0
        return
    end
    
    if curBubLevel[door_seq_1] and curBubLevel[door_seq_1] ~= 0 then
        return
    end
    
    if curBubLevel[door_seq_2] and curBubLevel[door_seq_2] ~= 0 then
        return
    end
     
    local doorx1,doory1 = getDoorXY(doorCol1, doorLine1)
    doorSprite1 = getBub(38, doorx1, doory1, door_seq_1)
    local rota1 = CCRotateTo:create(speNums.doorDie, speNums.doorRota)
    doorSprite1:runAction(rota1)
    shootLayer:addChild(doorSprite1, 1, tagNums["shootLayer"].shoot + door_seq_1)
    curBubLevel[door_seq_1] = doorSprite1
    sours[door_seq_1] = doorSprite1
    
    local doorx2,doory2 = getDoorXY(doorCol2, doorLine2)
    doorSprite2 = getBub(38, doorx2, doory2, door_seq_2)
    local rota2 = CCRotateTo:create(speNums.doorDie, speNums.doorRota)
    doorSprite2:runAction(rota2)
    shootLayer:addChild(doorSprite2, 1, tagNums["shootLayer"].shoot + door_seq_2)
    curBubLevel[door_seq_2] = doorSprite2
    sours[door_seq_2] = doorSprite2
    
    --停留 3 秒后删除
    performWithDelay(3, delDoorTwoSprites)
    doorFirstFlag = false
    doorLastFlag = false
    doorLast  = 0
    doorFirst = 0                    
    linkDoorNum1 = 0
    linkDoorNum2 = 0
    doorLine1 = 0
    doorLine2 = 0
    doorCol1  = 0
    doorCol2  = 0
end

function getDoorXY(col, line)
    local lx = col * bub_width 
    local ly = gStartY - line * bub_height
    if line % 2 == 0 then
        lx = col * bub_width + bub_width / 2
    end
    return lx - _x_py, ly
end

function getHexagonDoor(c_pot)
    local line = math.ceil(c_pot / 9)
    local col = c_pot % 9 
    if col == 0 then
        col = 9
    end
    return col, line
end

-------------door end---------------
function delDoorTwoSprites()
    if doorSprite1 then
        local doorSeq1 = doorSprite1.seq
        sours[doorSeq1] = 0
        curBubLevel[doorSeq1] = 0
        shootLayer:removeChild(doorSprite1)
        doorSprite1 = nil
    end
    if doorSprite2 then                        
        local doorSeq2 = doorSprite2.seq
        sours[doorSeq2] = 0
        curBubLevel[doorSeq2] = 0
        shootLayer:removeChild(doorSprite2)
        doorSprite2 = nil
    end
    recursionStart()
end

--------service deal---start--------
function chaDoorStart(comBubColor)
    local newSpr = nil
    if doorSprite1 and doorSprite2 then
        if curDoor.seq == doorSprite1.seq then
            --删除doorSprite1
            shootLayer:removeChild(doorSprite1)
            curBubLevel[doorSprite1.seq] = 0
            sours[doorSprite1.seq] = 0
            
            --创建新泡泡
            local doorSeq2 = doorSprite2.seq
            local doorX2,doorY2 = doorSprite2:getPosition()
            newSpr = getBub(comBubColor, doorX2, doorY2, doorSeq2)
            
            --删除doorSprite2
            shootLayer:removeChild(doorSprite2)            
            
            --加入新泡泡
            curBubLevel[doorSeq2] = newSpr
            sours[doorSeq2] = newSpr
            newSpr:setScale(0.1)
            newSpr:runAction(CCScaleTo:create(0.3, 1))
            shootLayer:addChild(newSpr, 1, tagNums["shootLayer"].shoot + newSpr.seq)
        else
            --删除doorSprite2
            shootLayer:removeChild(doorSprite2)
            curBubLevel[doorSprite2.seq] = 0
            sours[doorSprite2.seq] = 0
            
            --创建新泡泡
            local doorSeq1 = doorSprite1.seq
            local doorX1,doorY1 = doorSprite1:getPosition()
            newSpr = getBub(comBubColor, doorX1, doorY1, doorSeq1)
            
            --删除doorSprite1
            shootLayer:removeChild(doorSprite1)            
            
            --加入新泡泡
            curBubLevel[doorSeq1] = newSpr
            sours[doorSeq1] = newSpr
            newSpr:setScale(0.1)
            newSpr:runAction(CCScaleTo:create(0.3, 1))
            shootLayer:addChild(newSpr, 1, tagNums["shootLayer"].shoot + newSpr.seq)
        end        
            --释放资源
            doorSprite1 = nil
            doorSprite2 = nil
    end
    return newSpr
end

function isAroundDoor(line, col)
    isAroundFlag = false
    if line <= 0 or line > lineNum or col <= 0 or col > colNum then
		return
	end
	local xy = (line - 1) * colNum + col
    if curBubLevel[xy]  then
        local k = line % 2 
		if k == 0 then k = -1 end
		if not isAroundFlag then isAroundDoorImpl(line-1, col - k) end
		if not isAroundFlag then isAroundDoorImpl(line-1, col) end
		if not isAroundFlag then isAroundDoorImpl(line, col-1) end
		if not isAroundFlag then isAroundDoorImpl(line, col+1) end
		if not isAroundFlag then isAroundDoorImpl(line+1, col - k) end
		if not isAroundFlag then isAroundDoorImpl(line+1, col) end
	end
    
    return isAroundFlag
end

function isAroundDoorImpl(line, col)
	if line <= 0 or line > lineNum or col <= 0 or col > colNum then
		return
	end
	local xy = (line - 1) * colNum + col
    if curBubLevel[xy] and curBubLevel[xy] ~= 0 and curBubLevel[xy].bubColor == speBubs.bubDoor then
        curDoor = curBubLevel[xy]
        isAroundFlag = true
        return
	end
end
