function shootAndLink()
	if isShootLayerPause and runningBubble then
		dx = dx + py_x
		dy = dy + py_y
        if dx <= bub_width or dx + bub_width >= screenWidth then
			soundRebound()
            py_x = -py_x
		end

		if isSteel(runningBubble.bubColor) then
			runningBubble:setPosition(dx,dy)
			steelBall()
		elseif isLink() and compareColor ~= speBubs.down then
            linkStart()
		else
            if runningBubble then
                runningBubble:setPosition(dx, dy)
            end
			if isSucFlag or isFailFlag then
				removeRunningBubble()
			end
		end
	end
end

function getDistance(bub)
    if not bub or bub == 0 then
        cclog("----getDistance(bub)---nil-")
    end
    local flag = true
    local fixX, fixY = bub:getPosition()
    fixY = gStartY - fixY
    local nx, ny = dx, startY - dy
    if fixY + bub_height * 2 < ny then flag = false end
    local distance = (fixX - nx) * (fixX - nx) + (fixY - ny) * (fixY - ny)
    return flag, fixY, distance, ny
end

function isLink()
    stabFlag = false
	isSucFlag = false
	local borderHeight = startY - bub_height / 2
	for i = #curBubLevel, 1, -1 do
        if isFailFlag then return end
		if curBubLevel[i] and curBubLevel[i] ~= 0 then
			local flag, fixY, distance, ny = getDistance(curBubLevel[i])
            if not flag then break end
			if distance <= tBallDis then
                local table_k = getAroundExistByPots(curBubLevel[i].seq)
                if table_k and #table_k > 0 then
                    for k = 1, #table_k do
                        if curBubLevel[k] and curBubLevel[k] ~= 0 then
                            local flag_k, fixY_k, distance_k, ny = getDistance(curBubLevel[k])
                            if distance_k < distance then
                                distance = distance_k
                                i = k
                                fixY = fixY_k
                            end
                        end
                    end
                end                
                --记录v碰到的第一个球
                disBubF = curBubLevel[i]
                vBallFirstColor = disBubF.bubColor
                compareColor = runningBubble.bubColor
                if isIce(compareColor) then
					soundIceScreen()
                    removeRunningBubble()
                    iceBall()
                    break
                elseif isBubKey(vBallFirstColor)  and not isBomb(compareColor) then
                    if isBoss() then
                        bossEntry()
                    else
						soundKey()
                        gKeyBub = disBubF
                        gKey = 1
                    end
					break
				elseif vBallFirstColor == speBubs.down and not isBomb(compareColor) then
					soundBubSpeDown()
                    removeRunningBubble()
					downBall()
					link_com1(i, vBallFirstColor)
                    recursionStart()	
					break
				elseif vBallFirstColor == speBubs.bubGold then
                    soundBubSpeGold()
					link_com1(i, vBallFirstColor)
					goldAdd()
					isGold = true				
					break
				elseif vBallFirstColor == speBubs.energy then
					soundBubEnergy()
                    link_com1(i, vBallFirstColor)
					energyAdd()
					isEnergy = true				
					break
                elseif vBallFirstColor == speBubs.bubS and not isBomb(compareColor) then
					soundAddScore()
					link_com1(i, vBallFirstColor)
					inScoreAdd()
					isInScore = true	
					break
				elseif vBallFirstColor == speBubs.empty then
					soundBubEmpty()
                    link_com1(i, vBallFirstColor)
                    isEmpty = true										
					break
				end
				if math.abs(ny - fixY) < speNums.reHeight and vBallFirstColor ~= speBubs.bubDoor then
					soundRebound()
					py_x = -py_x
					stabFlag = false
					break
				end
				stabFlag = true
				break
			elseif dy >= borderHeight then
                disBubF = nil
				compareColor = runningBubble.bubColor
				dy = borderHeight
				if isIce(compareColor) then
					soundIceScreen()
                    removeRunningBubble()
                    iceBall()
                    break
				end	
				stabFlag = true
				break
			end
		end		
	end
    return stabFlag
end

function link_com1(i, color)
    sours[i] = 0
    curBubLevel[i] = 0
    stabFlag = false
    if color == speBubs.bubGold then
        if not runningBubble or not disBubF or disBubF == 0 or runningBubble == 0 then return end
        --金币特效
        local goldEff_x, goldEff_y = runningBubble:getPosition()
        local g_x, g_y = disBubF:getPosition()
        particleEffect(g_x, g_y, speBubs.empty)
        collGoldEff(goldEff_x, goldEff_y)
    elseif color == speBubs.energy then
        if not disBubF or disBubF == 0 then return end
        energyEffect(disBubF:getPosition())					
        local g_x, g_y = disBubF:getPosition()
		particleEffect(g_x, g_y, speBubs.empty)
    elseif color == speBubs.empty then
        if not disBubF or disBubF == 0 then return end
        local g_x, g_y = disBubF:getPosition()
        particleEffect(g_x, g_y, speBubs.empty)
    end
    if disBubF and disBubF ~= 0 then
        shootLayer:removeChild(disBubF)
    end
end

function linkStart()
    local lsFlag = dealRunBub()
	if pot == -1 then
		return
    end
    if lsFlag then
        performWithDelay(speNums.jumpTime, link_impl)
    else
        link_impl()
    end
end

function dealRunBub()
    dealRunFlag = true
	removeRunningBubble()
	local rx, ry, x6, y6 = 0, 0, 0, 0
    if disBubF then
        rx, ry, x6, y6 = new_dis(disBubF.seq, dx, dy)
    else
        rx, ry, x6, y6 = firstLine_impl(dx, dy)
    end
    if pot == -1 then
		return
    end
    bombEff_x, bombEff_y = rx, ry
    if isAroundDoor(y6, x6) then
		soundDoorActive()
        local newSpr = chaDoorStart(compareColor)
        if newSpr and newSpr ~= 0 then
            x6, y6 = new_hex(newSpr.seq)
            pot = newSpr.seq
            bombEff_x, bombEff_y = newSpr:getPosition()
        end
        set_x6_y6(y6, x6)
        return true
    else
        local tmpss = getBub(compareColor, rx, ry, pot)
        curBubLevel[pot] = tmpss
        sours[pot] = tmpss
        shootLayer:addChild(tmpss, 1, tagNums["shootLayer"].shoot + pot)
        lastDelFlag = false
        tmpss = nil       
        set_x6_y6(y6, x6)
        return false
    end
end

function set_x6_y6(y6, x6)
    y6_q = y6
    x6_q = x6
    if y6_q > lineNum then lineNum = y6_q end
    pot = (y6 - 1) * colNum + x6
    resetTable()
end

function link_impl()
    local c = 3
	if isBomb(compareColor) then
		bombBall(y6_q, x6_q)
        if bomb_Key then
            bomb_Key = false
            bombEffect()
            if isBoss() then
                bossEntry()
            else
                keyDeal(disBubF)
            end
            return
        else
            gBomb = 1
            return
        end
		c = 4
	elseif compareColor == speBubs.black then
		soundBubSpeBlack()
		blackBall()
		return
    elseif compareColor == speBubs.mul then 
        mulBall(y6_q, x6_q)
        mulBallAround6(y6_q, x6_q)
        if existDye(pot) then
            searchDyeBall(y6_q, x6_q)
            dyeBall()
        elseif existSplit(pot) then
            searchSplitBall(y6_q, x6_q)
            splitBall()
        end
    elseif isBubV(compareColor) then
		soundBubVCome()
        bubVImpl()
	end
    recursionLink2(y6_q, x6_q)
    if not isSplit(vBallFirstColor) and not isDye(vBallFirstColor) then
        shakeAround(pot)
    end
    isAroundDown(pot)
    gLinked = 1
    return
end

function lastDelLinkBubs()
    local detain_RemoveBubTable = getStabBub()
    local isDelFlag = removeStabBubs(detain_RemoveBubTable)
	if not isDelFlag then
		if vBallFirstColor == speBubs.plate1 then
			soundBubWood()
		elseif vBallFirstColor == speBubs.plate2 then
			soundBubStone()
		else
             --hujian
            -- bubbleLighting(bombEff_x, bombEff_y)
			soundComClack()
		end
	end
    if existDye(pot) and not dye_flag then
        searchDyeBall(y6_q, x6_q)
		dyeBall()
    elseif existQues(pot) then
        quesBall(qqBall)
        if existDye(pot) then
            searchDyeBall(y6_q, x6_q)
            dyeBall()
        elseif existSplit(pot) then
            searchSplitBall(y6_q, x6_q)
            splitBall()
        end
    elseif existSplit(pot) then
        searchSplitBall(y6_q, x6_q)
        splitBall()
    end
    if (isDelFlag or isGold or isEmpty or isEnergy or isInScore) and not isSucFlag then
		recursionStart()
	end
    lastDelFlag = true
	runFlyFlag = true
end

function removeStabBubs(stabBub)
    if isFailFlag then return end
    seqTable = {}
	local delBubFlag = false
	if #stabBub >= 3 or isBubV(compareColor) then
        seqTable = stabBub
        delBubFlag = true
		conTimeChange()
		thisScore = 0
		infoAll.sucShootNum = infoAll.sucShootNum + 1
		scoreSeq = {}
		for m = 1, #stabBub do
			sours[stabBub[m].seq] = 0
			curBubLevel[stabBub[m].seq] = 0
            if m <= 3 then
				scoreSeq[m] = 100
			else
				scoreSeq[m] = (m - 2) * 100
			end
			addScore(m, 'link', #stabBub)
			getThisLinkScore(m)
		end
		if isConTime() then
            local conNumTmp = conNum
            if conNumTmp > 5 then conNumTmp = 5 end
			curScores = curScores + conNumTmp * thisScore
            infoAll.todayScore = infoAll.todayScore + conNumTmp * thisScore
		end
        seqDelSchedule()
	else
		conNum = 1
	end
	return delBubFlag
end

--炸弹单独处理
function bombDelLinkBubs()
    bombRemoveStabBubs(getStabBub())    
    recursionStart()
end

function bombRemoveStabBubs(stabBub)
    if isFailFlag then return end
    bombEffect()
    seqTable = {}
	local delBubFlag = false
	if #stabBub >= 1 then
        seqTable = stabBub
        delBubFlag = true
		conTimeChange()
		thisScore = 0
		infoAll.sucShootNum = infoAll.sucShootNum + 1
		scoreSeq = {}
		for m = 1, #stabBub do
			sours[stabBub[m].seq] = 0
			curBubLevel[stabBub[m].seq] = 0
            if m <= 3 then
				scoreSeq[m] = 100
			else
				scoreSeq[m] = (m - 2) * 100
			end
			addScore(m, 'link', #stabBub)
			getThisLinkScore(m)
            if stabBub[m].bubColor == speBubs.bubGold then
                if not stabBub[m] or stabBub[m] == 0 then break end
                --金币特效
                local goldEff_x, goldEff_y = stabBub[m]:getPosition()
                collGoldEff(goldEff_x, goldEff_y + startY - gStartY)
				goldAdd()
				isGold = true
			end
			if stabBub[m].bubColor == speBubs.energy then
                if not stabBub[m] or stabBub[m] == 0 then break end
                local enEff_x, enEff_y = stabBub[m]:getPosition()
                energyEffect(enEff_x, enEff_y)
				energyAdd()
				isEnergy = true
			end
		end
		if isConTime() then
            local conNumTmp = conNum
            if conNumTmp > 5 then conNumTmp = 5 end
			curScores = curScores + conNumTmp * thisScore
            infoAll.todayScore = infoAll.todayScore + conNumTmp * thisScore
		end
        seqImpl()
	end
	return delBubFlag
end

function deepSeaBombRemoveStabBubs(stabBub)
    if isFailFlag then return end
    bombEffect()
    seqTable = {}
	local delBubFlag = false
	if #stabBub >= 1 then
        seqTable = stabBub
        delBubFlag = true
		conTimeChange()
		thisScore = 0
		infoAll.sucShootNum = infoAll.sucShootNum + 1
		scoreSeq = {}
		local sea_i = 0
		for m = 1, #stabBub do
			sea_i = sea_i + 1
			if isBubKey(stabBub[m].bubColor) and isBoss() then
			
			else
				sours[stabBub[m].seq] = 0
				curBubLevel[stabBub[m].seq] = 0
			end
            if m <= 3 then
				scoreSeq[m] = 100
			else
				scoreSeq[m] = (m - 2) * 100
			end
			if sea_i == 1 then
				--addScore(m, 'link', #stabBub)
				addScore_deepSeaBomb(#stabBub)
				getThisLinkScore(m)				
			end
            if stabBub[m].bubColor == speBubs.bubGold then
                if not stabBub[m] or stabBub[m] == 0 then break end
                --金币特效
                local goldEff_x, goldEff_y = stabBub[m]:getPosition()
                collGoldEff(goldEff_x, goldEff_y + startY - gStartY)
				goldAdd()
				isGold = true
			end
			if stabBub[m].bubColor == speBubs.energy then
                if not stabBub[m] or stabBub[m] == 0 then break end
                local enEff_x, enEff_y = stabBub[m]:getPosition()
                energyEffect(enEff_x, enEff_y)
				energyAdd()
				isEnergy = true
			end
		end
		if isConTime() then
            local conNumTmp = conNum
            if conNumTmp > 5 then conNumTmp = 5 end
			curScores = curScores + conNumTmp * thisScore
            infoAll.todayScore = infoAll.todayScore + conNumTmp * thisScore
		end
        --seqImpl()
        seqImpl_deepSeaBomb()
	end
	return delBubFlag
end

function recursionLink2(line, col)
    if line <= 0 or line > lineNum or col <= 0 or col > colNum then
		return
	end
	local xy = (line - 1) * colNum + col
	if curBubLevel[xy] and curBubLevel[xy] ~= 0  and curBubLevel[xy].isFind == 0 
		and  canRemove(curBubLevel[xy].bubColor) then
		curBubLevel[xy].isFind = 1
        local k = line % 2 
		if k == 0 then k = -1 end
		recursionLink2(line - 1, col - k)
		recursionLink2(line - 1, col)
		recursionLink2(line, col - 1)
		recursionLink2(line, col + 1)
		recursionLink2(line + 1, col - k)
		recursionLink2(line + 1, col)
	end
end

function canRemove(cur_color)
    if cur_color == compareColor or cur_color == speBubs.mul then
		return true
	end

	if isBase(compareColor) and compareColor + speNums.baseLast == cur_color then
		return true
	end

	if isSplit(compareColor) and compareColor - speNums.baseLast == cur_color then
		return true
	end
	return false
end

function getStabBub()
	local linkBubs = {}
    for j = 1, #curBubLevel do
		if curBubLevel[j] and curBubLevel[j] ~= 0 and curBubLevel[j].isFind == 1 
             and curBubLevel[j].bubColor ~= speBubs.plate2 then
            table.insert(linkBubs, curBubLevel[j])
		end
	end
	return linkBubs
end

