local SCROLL_TO_VALID_RANGE_SPEED = 800
--stre单点触摸
function streTouch_single()
    local frameTime         = 0
    local touch             = nil
    local layer             = streTcHDLayer
    local swiping           = nil
    local enterFrameHandle  = nil
    local validTouchTop     = 0
    local validTouchBottom  = 0
    local validTouchHeight  = 0
    local marginTop = 0
    local marginBottom = 0
    
    local touchBeginPoint = nil
    if device == "iphone5" then
        layer.topY = 83
    else
        layer.topY = 0
    end
    
    layer.topX = 0
    layer.bottomY = 510 - validTouchHeight + 1
    if layer.bottomY < 0 then layer.bottomY = 0 end
    validTouchTop    = screenHeight - marginTop - 1
    validTouchBottom = marginBottom
    validTouchHeight = validTouchTop - validTouchBottom + 1
    
    local function snapLayer(isAutoScroll)
        local ny = layer.y
        if layer.y < layer.topY then
            ny = layer.topY
        elseif layer.y > layer.bottomY then
            ny = layer.bottomY
        end
        
        if layer.y ~= ny then
            local time = math.abs(layer.y - ny) / SCROLL_TO_VALID_RANGE_SPEED
            local easing = "backOut"
            if isAutoScroll then easing = {"inOut", 2} end
            layer:runAction(CCMoveTo:create(time,ccp(streTcUILayer:getPositionX(), ny)))
        end
    end

    local function onTouchBegan(x, y)
		soundHDAchStre()
        touchBeginPoint = {x = x, y = y}
        
        if y > validTouchTop or y < validTouchBottom then return false end
        touch = {
            initTouchY      = y,
            initLayerY      = layer.y,
            isMaybeTap      = (swiping == nil), -- 如果触摸开始时视图尚在自动卷动，则不考虑 tap 事件
            lastTouchTime   = frameTime,
            lastTouchY      = y,
            isMaybySwiping  = false,
            swipingBeganTime= 0,
            swipingBeganY   = 0
        }
        swiping = nil
        return true
    end

    local function onTouchMoved(x, y)
        if touch.lastTouchY == y then
            -- 如果两次触摸事件之间，坐标没有变化，则取消轻扫状态
            touch.isMaybySwiping = false
        else
            -- 如果当前处于轻扫状态，但本次事件距离上次事件的间隔时间超过一定范围，则取消轻扫状态
            if touch.isMaybySwiping then
                if frameTime - touch.lastTouchTime > 0.034 then
                    touch.isMaybySwiping = false
                end
            else
                touch.isMaybySwiping   = true
                touch.swipingBeganTime = frameTime
                touch.swipingBeganY    = y
            end
        end

        touch.lastTouchY = y
        touch.lastTouchTime = frameTime

        if touch.isMaybeTap and math.abs(y - touch.initTouchY) >= 10 then
            -- 触摸移动范围超过 10 点，则不再视为 tap 操作
            touch.isMaybeTap = false
        end
        if not touch.isMaybeTap then
            local ny = touch.initLayerY + (y - touch.initTouchY)
            layer.y = ny
        end
    end

    local function onTouchEnded(x, y)
        if layer.y <= layer.topY or layer.y >= layer.bottomY then
            --cclog("topy = "..layer.topY..",layer.bottomY ="..layer.bottomY)
            snapLayer()
        elseif touch.isMaybySwiping then
            -- 根据一定时间范围内手指的滑动速度计算惯性
           local time = frameTime - touch.swipingBeganTime
            if time > 0 then
                local offset = y - touch.swipingBeganY
                local speed = math.abs(offset) / time
                swiping = {speed = speed, direction = offset < 0} -- true = up, false = down
            end            
        end
    end  

    local function onTouch(eventType, x, y)
        if device == "ipad" then x = x - 64 y = y - 32
        elseif device == "iphone5" then y = y - 88
        end
        if eventType == CCTOUCHBEGAN then
            return onTouchBegan(x, y)
        elseif eventType == CCTOUCHMOVED then
            return onTouchMoved(x, y)
        else            
            return onTouchEnded(x, y)
        end
    end
    layer:registerScriptTouchHandler(onTouch,false,1,true)
    layer:setTouchEnabled(true)
end

--失败中的增强
--stre单点触摸
function streTouch_single_fail()
    local frameTime         = 0
    local touch             = nil
    local layer             = streTcHDLayer_fail
    local swiping           = nil
    local enterFrameHandle  = nil
    local validTouchTop     = 0
    local validTouchBottom  = 0
    local validTouchHeight  = 0
    local marginTop = 0
    local marginBottom = 0
    
    local touchBeginPoint = nil
    if device == "iphone5" then
        layer.topY = 83
    else
        layer.topY = 0
    end
        
    layer.topX = 0
    layer.bottomY = 510 - validTouchHeight + 1
    if layer.bottomY < 0 then layer.bottomY = 0 end
    validTouchTop    = screenHeight - marginTop - 1
    validTouchBottom = marginBottom
    validTouchHeight = validTouchTop - validTouchBottom + 1
    
    local function snapLayer(isAutoScroll)
        local ny = layer.y
        if layer.y < layer.topY then
            ny = layer.topY
        elseif layer.y > layer.bottomY then
            ny = layer.bottomY
        end
        
        if layer.y ~= ny then
            local time = math.abs(layer.y - ny) / SCROLL_TO_VALID_RANGE_SPEED
            local easing = "backOut"
            if isAutoScroll then easing = {"inOut", 2} end
            layer:runAction(CCMoveTo:create(time,ccp(streTcUILayer_fail:getPositionX(), ny)))
        end
    end

    local function onTouchBegan(x, y)
		soundHDAchStre()
        touchBeginPoint = {x = x, y = y}
        
        if y > validTouchTop or y < validTouchBottom then return false end
        touch = {
            initTouchY      = y,
            initLayerY      = layer.y,
            isMaybeTap      = (swiping == nil), -- 如果触摸开始时视图尚在自动卷动，则不考虑 tap 事件
            lastTouchTime   = frameTime,
            lastTouchY      = y,
            isMaybySwiping  = false,
            swipingBeganTime= 0,
            swipingBeganY   = 0
        }
        swiping = nil
        return true
    end

    local function onTouchMoved(x, y)
        if touch.lastTouchY == y then
            -- 如果两次触摸事件之间，坐标没有变化，则取消轻扫状态
            touch.isMaybySwiping = false
        else
            -- 如果当前处于轻扫状态，但本次事件距离上次事件的间隔时间超过一定范围，则取消轻扫状态
            if touch.isMaybySwiping then
                if frameTime - touch.lastTouchTime > 0.034 then
                    touch.isMaybySwiping = false
                end
            else
                touch.isMaybySwiping   = true
                touch.swipingBeganTime = frameTime
                touch.swipingBeganY    = y
            end
        end

        touch.lastTouchY = y
        touch.lastTouchTime = frameTime

        if touch.isMaybeTap and math.abs(y - touch.initTouchY) >= 10 then
            -- 触摸移动范围超过 10 点，则不再视为 tap 操作
            touch.isMaybeTap = false
        end
        if not touch.isMaybeTap then
            local ny = touch.initLayerY + (y - touch.initTouchY)
            layer.y = ny
        end
    end

    local function onTouchEnded(x, y)
        if layer.y <= layer.topY or layer.y >= layer.bottomY then
            --cclog("topy = "..layer.topY..",layer.bottomY ="..layer.bottomY)
            snapLayer()
        elseif touch.isMaybySwiping then
            -- 根据一定时间范围内手指的滑动速度计算惯性
           local time = frameTime - touch.swipingBeganTime
            if time > 0 then
                local offset = y - touch.swipingBeganY
                local speed = math.abs(offset) / time
                swiping = {speed = speed, direction = offset < 0} -- true = up, false = down
            end            
        end
    end  

    local function onTouch(eventType, x, y)
        if device == "ipad" then x = x - 64 y = y - 32
        elseif device == "iphone5" then y = y - 88
        end
        if eventType == CCTOUCHBEGAN then
            return onTouchBegan(x, y)
        elseif eventType == CCTOUCHMOVED then
            return onTouchMoved(x, y)
        else            
            return onTouchEnded(x, y)
        end
    end
    layer:registerScriptTouchHandler(onTouch,false,1,true)
    layer:setTouchEnabled(true)
end
--[[
--ache单点触摸
function acheTouch_single()
    local frameTime         = 0
    local touch             = nil
    local layer             = acheTcHDLayer
    local swiping           = nil
    local enterFrameHandle  = nil
    local validTouchTop     = 0
    local validTouchBottom  = 0
    local validTouchHeight  = 0
    local marginTop = 0
    local marginBottom = 0
    
    local touchBeginPoint = nil
    if device == "iphone5" then
        layer.topY = 88
    else
        layer.topY = 0
    end
        
    layer.topX = 0
    layer.bottomY = 4020 - validTouchHeight + 1
    if layer.bottomY < 0 then layer.bottomY = 0 end
    validTouchTop    = screenHeight - marginTop - 1
    validTouchBottom = marginBottom
    validTouchHeight = validTouchTop - validTouchBottom + 1
    
    local function snapLayer(isAutoScroll)
        local ny = layer.y
        if layer.y < layer.topY then
            ny = layer.topY
        elseif layer.y > layer.bottomY then
            ny = layer.bottomY
        end
        
        if layer.y ~= ny then
            local time = math.abs(layer.y - ny) / SCROLL_TO_VALID_RANGE_SPEED
            local easing = "backOut"
            if isAutoScroll then easing = {"inOut", 2} end
            layer:runAction(CCMoveTo:create(time,ccp(acheTcUILayer:getPositionX(), ny)))
        end
    end

    local function onTouchBegan(x, y)
		soundHDAchStre()
        touchBeginPoint = {x = x, y = y}
        
        if y > validTouchTop or y < validTouchBottom then return false end
        touch = {
            initTouchY      = y,
            initLayerY      = layer.y,
            isMaybeTap      = (swiping == nil), -- 如果触摸开始时视图尚在自动卷动，则不考虑 tap 事件
            lastTouchTime   = frameTime,
            lastTouchY      = y,
            isMaybySwiping  = false,
            swipingBeganTime= 0,
            swipingBeganY   = 0
        }
        swiping = nil
        return true
    end

    local function onTouchMoved(x, y)
        if touch.lastTouchY == y then
            -- 如果两次触摸事件之间，坐标没有变化，则取消轻扫状态
            touch.isMaybySwiping = false
        else
            -- 如果当前处于轻扫状态，但本次事件距离上次事件的间隔时间超过一定范围，则取消轻扫状态
            if touch.isMaybySwiping then
                if frameTime - touch.lastTouchTime > 0.034 then
                    touch.isMaybySwiping = false
                end
            else
                touch.isMaybySwiping   = true
                touch.swipingBeganTime = frameTime
                touch.swipingBeganY    = y
            end
        end

        touch.lastTouchY = y
        touch.lastTouchTime = frameTime

        if touch.isMaybeTap and math.abs(y - touch.initTouchY) >= 10 then
            -- 触摸移动范围超过 10 点，则不再视为 tap 操作
            touch.isMaybeTap = false
        end
        if not touch.isMaybeTap then
            local ny = touch.initLayerY + (y - touch.initTouchY)
            layer.y = ny
        end
    end

    local function onTouchEnded(x, y)
        if layer.y <= layer.topY or layer.y >= layer.bottomY then
            snapLayer()
        elseif touch.isMaybySwiping then
            -- 根据一定时间范围内手指的滑动速度计算惯性
           local time = frameTime - touch.swipingBeganTime
            if time > 0 then
                local offset = y - touch.swipingBeganY
                local speed = math.abs(offset) / time
                swiping = {speed = speed, direction = offset < 0} -- true = up, false = down
            end            
        end
    end  

    local function onTouch(eventType, x, y)
        if device == "ipad" then x = x - 64 y = y - 32
        elseif device == "iphone5" then y = y - 88
        end
        if eventType == CCTOUCHBEGAN then
            return onTouchBegan(x, y)
        elseif eventType == CCTOUCHMOVED then
            return onTouchMoved(x, y)
        else            
            return onTouchEnded(x, y)
        end
    end
    layer:registerScriptTouchHandler(onTouch,false,1,true)
    layer:setTouchEnabled(true)
end
]]
--关卡选择单点触摸
function secTouch_single()
    local frameTime         = 0
    local touch             = nil
    local layer             = hdSecLayer
    local swiping           = nil
    local enterFrameHandle  = nil
    local validTouchTop     = 0
    local validTouchBottom  = 0
    local validTouchHeight  = 0

    local validTouchLeft    = 0
    local validTouchRight   = 0
    local validTouchWidth   = 0
    local marginLeft        = 0
    local marginRight       = 0

    local marginTop = 0
    local marginBottom = 0
    
    local touchBeginPoint = nil
    layer.topY = 0
    layer.topX = 0
    -- layer.bottomY = bottomHD - validTouchHeight + 1
    layer.leftX = bottomHD - validTouchWidth + 1 
    layer.rightX = bottomHD     --550*0.7
    -- if layer.bottomY < 0 then layer.bottomY = 0 end
    if layer.leftX < 0 then layer.leftX = 0 end
    -- validTouchTop    = screenHeight - marginTop - 1
    -- validTouchBottom = marginBottom
    -- validTouchHeight = validTouchTop - validTouchBottom + 1
    validTouchRight = screenWidth - marginRight - 1
    validTouchLeft = marginLeft
    validTouchWidth = validTouchRight - validTouchLeft + 1
    
    local function snapLayer(isAutoScroll)
        -- local ny = layer.y
        -- if layer.y < layer.topY then
        --     ny = layer.topY
        -- elseif layer.y > layer.bottomY then
        --     ny = layer.bottomY
        -- end
        local nx = layer.x
        if layer.x > layer.topX then
        --if layer.x > layer.rightX then
            nx = layer.topX
        elseif layer.x < layer.leftX then
            --nx = layer.leftX         
        end
        
        -- if layer.y ~= ny then
        --     local time = math.abs(layer.y - ny) / SCROLL_TO_VALID_RANGE_SPEED
        --     local easing = "backOut"
        --     if isAutoScroll then easing = {"inOut", 2} end
        --     layer:runAction(CCMoveTo:create(time,ccp(sepIsLayer:getPositionX(), ny)))
        -- end
        if layer.x ~= nx then
            local time = math.abs(layer.x-nx)/480
            local easing = "backOut"
            if isAutoScroll then easing = {"inOut",2} end
            layer:runAction(CCMoveTo:create(time,ccp(nx,sepIsLayer:getPositionY())))
        end
    end

    local function onTouchBegan(x, y)
        touchBeginPoint = {x = x, y = y}        
        -- if y > validTouchTop or y < validTouchBottom then return false end
        if x > validTouchRight or x < validTouchLeft then return false end
        touch = {
            -- initTouchY      = y,
            -- initLayerY      = layer.y,
            initTouchX      = x,
            initLayerX      = layer.x,
            isMaybeTap      = (swiping == nil), -- 如果触摸开始时视图尚在自动卷动，则不考虑 tap 事件
            lastTouchTime   = frameTime,
            -- lastTouchY      = y,
            lastTouchX      = x,
            isMaybySwiping  = false,
            swipingBeganTime= 0,
            -- swipingBeganY   = 0
            swipingBeganX   = 0
        }
        swiping = nil
        return true
    end

    local function onTouchMoved(x, y)
        -- if touch.lastTouchY == y then
        if touch.lastTouchX == x then
            -- 如果两次触摸事件之间，坐标没有变化，则取消轻扫状态
            touch.isMaybySwiping = false
        else
            -- 如果当前处于轻扫状态，但本次事件距离上次事件的间隔时间超过一定范围，则取消轻扫状态
            if touch.isMaybySwiping then
                if frameTime - touch.lastTouchTime > 0.034 then
                    touch.isMaybySwiping = false
                end
            else
                touch.isMaybySwiping   = true
                touch.swipingBeganTime = frameTime
                -- touch.swipingBeganY    = y
                touch.swipingBeganX    = x
            end
        end

        -- touch.lastTouchY = y
        touch.lastTouchX = x
        touch.lastTouchTime = frameTime

        -- if touch.isMaybeTap and math.abs(y - touch.initTouchY) >= 10 then
        if touch.isMaybeTap and math.abs(x - touch.initTouchX) >= 10 then
            -- 触摸移动范围超过 10 点，则不再视为 tap 操作
            touch.isMaybeTap = false
        end
        if not touch.isMaybeTap then
            -- local ny = touch.initLayerY + (y - touch.initTouchY)
            -- layer.y = ny
            local nx = touch.initLayerX + (x - touch.initTouchX)
            layer.x = nx
        end
    end

    local function onTouchEnded(x, y)
        if math.abs(x - touchBeginPoint.x) <= 15 and math.abs(y - touchBeginPoint.y) <= 15 then           
            touchSecSma(x,y)
            return 
        end
        -- if layer.y <= layer.topY or layer.y >= layer.bottomY then
        if layer.x <= layer.topX or layer.x >= layer.leftX then
            snapLayer()
        elseif touch.isMaybySwiping then
            -- 根据一定时间范围内手指的滑动速度计算惯性
           local time = frameTime - touch.swipingBeganTime
            if time > 0 then
                -- local offset = y - touch.swipingBeganY
                local offset = x - touch.swipingBeganX
                local speed = math.abs(offset) / time
                swiping = {speed = speed, direction = offset < 0} -- true = up, false = down
            end            
        end
    end  

    local function onTouch(eventType, x, y)
        if device == "ipad" then x = x - 64 y = y - 32
        elseif device == "iphone5" then y = y - 88
        end
        if eventType == CCTOUCHBEGAN then
            return onTouchBegan(x, y)
        elseif eventType == CCTOUCHMOVED then
            return onTouchMoved(x, y)
        else            
            return onTouchEnded(x, y)
        end
    end
    layer:registerScriptTouchHandler(onTouch,false,1,true)
    layer:setTouchEnabled(true)
end
